import os, sys, sqlite3, jumpy

if sys.argv[1] == 'init':
	# initial call, create a player
	pms.addPlayer(
		name = 'pixplayer',
		cmd = [sys.argv[0], 'play', '${filename}'],
		# this player supports the 'pix' psuedo-format with image/jpeg mimetype
		supported = 'f:pix m:image/jpeg',
		mediatype = PMS_IMAGE,
		purpose = PMS_MISC_PLAYER,
		desc = 'View images directly from db.',
		playback = '0:0'
	)

	# add a callback folder
	pms.addFolder('/Pictures', [sys.argv[0], 'open'])

elif sys.argv[1] == 'open':
	# populate folder
	conn = sqlite3.connect('pictures.db')
	# add each picture as a 'pix' format item with its id as filename
	for image_id, name, ext in conn.execute("SELECT id, FILE_NAME, TYPE FROM PICTURES"):
		if ext.lower().endswith('jpg'):
			pms.addMedia(name, 'pix', str(image_id), None)
	conn.close()

elif sys.argv[1] == 'play':
	# we are playing a 'pix' item.
	# get the corresponding image data from the db
	image_id = int(sys.argv[2])
	conn = sqlite3.connect('pictures.db')
	cursor = conn.cursor()
	sql = "SELECT PICTURE FROM PICTURES WHERE id = :id"
	param = {'id': image_id}
	cursor.execute(sql, param)
	data = cursor.fetchone()[0]
	conn.close()

	# write the data directly to the UMS (named pipe) output file
	outfile = os.environ['OUTFILE']
	with open(outfile, 'wb') as output_file:
		output_file.write(data)

